
; *****************************************************************************
;
;                  Emultor diskety 360 KB v pamti
;
; *****************************************************************************

code     SEGMENT
         ASSUME    cs:code,ds:code

         dd        -1                       ; adresa nsledujcho driveru
         dw        0800h                    ; atributy
         dw        offset Strateg           ; offset rutiny strategie
         dw        offset Prerus            ; offset rutiny peruen
PocDisku db        1                        ; poet obsluhovanch disk
         db        7 dup(0)                 ; rezervovno

         db        'RAM360K V 1.00'         ; identifikace RAM-DISKu

format   db        0                        ; formt diskety

; -----------------------------------------------------------------------------
;
; -----------------------------------------------------------------------------

AdrZahl  dd        0                        ; adresa zhlav zazen



tabbpb   dw        offset bpb

bpb      label     byte                   ;* blok parametr BIOS BPB disku



SizeSekt dw        512                      ; 00h: poet bajt na sektor
SizeBlok db        1                        ; 02h: poet sektor na alok. blok
RezSekt  dw        1                        ; 03h: zavdc a rezerv. sektory
NumFat   db        2                        ; 05h: poet alokanch tabulek FAT
MaxRoot  dw        4*16                     ; 06h: max. poet pol. zkl. adres.
MaxSekt  dw        720                      ; 08h: celkov poet sektor disku
Descript db        0fdh                     ; 0ah: popisova mdia
SektFat  dw        3                        ; 0bh: poet sektor v jedn FAT
                                          ;* od DOS 3.00
SektTrck dw        9                        ; 0dh: poet sektor na stopu
NumHead  dw        2                        ; 0fh: poet hlav
HidSekt  dd        0                        ; 11h: poet skrytch sektor

; 1 BOOT
; 2*3 FAT
; 4 ROOT
; 709 data
; ----------
; 720 celkem

; -----------------------------------------------------------------------------
;        ten sektor z RAM-DISKu
; -----------------------------------------------------------------------------
; VSTUP: DS:DI=adresa bufferu
;        DX=poten sektor ke ten
;        CX=poet sektor ke ten
; -----------------------------------------------------------------------------
; VSTUP:CY=chyba operace
;        CX=poet zbylch sektor
; -----------------------------------------------------------------------------

PUBLIC   ReadSekt
ReadSekt PROC      NEAR

         push      dx
         push      si
         push      di

                                          ;* vpoet zdrojov adresy
         mov       ax,dx                    ; poten sektor
         call      GetExt                   ; vpoet zdrojov adresy
         mov       si,ax                    ; ni slovo zdrojov adresy

                                          ;* vpoet clov adresy
         xor       dh,dh
         mov       ax,ds                    ; segment clov adresy
         add       ax,ax                    ; segment * 2
         adc       dh,dh                    ; penos do vyho bajtu
         add       ax,ax                    ; segment * 2
         adc       dh,dh                    ; penos do vyho bajtu
         add       ax,ax                    ; segment * 2
         adc       dh,dh                    ; penos do vyho bajtu
         add       ax,ax                    ; segment * 2
         adc       dh,dh                    ; penos do vyho bajtu
         add       di,ax                    ; piten penosu ze segmentu
         adc       dh,0                     ; penos do vyho bajtu

         call      BlokMove                 ; ten sektor

         pop       di
         pop       si
         pop       dx
         ret

ReadSekt ENDP

; -----------------------------------------------------------------------------
;        Zpis sektor do RAM-DISKu
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=adresa bufferu
;        DX=poten sektor k uloen
;        CX=poet sektor k uloen
; -----------------------------------------------------------------------------
; VSTUP:CY=chyba operace
;        CX=poet zbylch sektor
; -----------------------------------------------------------------------------

PUBLIC   WritSekt
WritSekt PROC      NEAR

         push      dx
         push      si
         push      di

                                          ;* vpoet clov adresy
         mov       ax,dx                    ; poten sektor
         call      GetExt                   ; vpoet clov adresy
         mov       di,ax                    ; ni slovo clov adresy
         mov       dh,dl                    ; vy bajt clov adresy

                                          ;* vpoet zdrojov adresy
         xor       dl,dl
         mov       ax,ds                    ; segment zdrojov adresy
         add       ax,ax                    ; segment * 2
         adc       dl,dl                    ; penos do vyho bajtu
         add       ax,ax                    ; segment * 2
         adc       dl,dl                    ; penos do vyho bajtu
         add       ax,ax                    ; segment * 2
         adc       dl,dl                    ; penos do vyho bajtu
         add       ax,ax                    ; segment * 2
         adc       dl,dl                    ; penos do vyho bajtu
         add       si,ax                    ; piten penosu ze segmentu
         adc       dl,0                     ; penos do vyho bajtu

         call      BlokMove                 ; zpis sektor

         pop       di
         pop       si
         pop       dx
         ret

WritSekt ENDP

; -----------------------------------------------------------------------------
;        Vpoet adresy v roziujc pamti
; -----------------------------------------------------------------------------
; VSTUP: AX=slo sektoru
; VSTUP:DL:AX=adresa v roziujc pamti
; -----------------------------------------------------------------------------

PUBLIC   GetExt
GetExt   PROC      NEAR

         push      cx
         push      dx
         mov       cx,512                   ; dlka sektoru
         mul       cx                       ; pepoet sektor na bajty
         mov       cl,dl                    ; vy bajt adresy
         pop       dx
         mov       dl,cl                    ; vy bajt adresy
         pop       cx
         add       ax,cs:[TopMem]           ; piten potku pamti
         adc       dl,byte ptr cs:[TopMem+2]; vy bajt adresy
         ret

GetExt   ENDP

; -----------------------------------------------------------------------------
;        Tabulka popisova pro pesun dat
; -----------------------------------------------------------------------------

GDT      label     word

                                          ;* przdn popisova
GDT01    dw        0                        ; 0: omezen segmentu
GDT02    dw        0                        ; 2: ni slovo adresy
GDT03    db        0                        ; 4: vy bajt adresy
GDT04    db        0                        ; 5: bajt pstupovch prv
GDT05    dw        0                        ; 6: (rezervovno)

                                          ;* popisova tabulky GDT
GDT11    dw        0                        ; 0: omezen segmentu
GDT12    dw        0                        ; 2: ni slovo adresy
GDT13    db        0                        ; 4: vy bajt adresy
GDT14    db        0                        ; 5: bajt pstupovch prv
GDT15    dw        0                        ; 6: (rezervovno)

                                          ;* popisova zdrojovho bloku dat
GDT21    dw        0                        ; 0: omezen segmentu
GDT22    dw        0                        ; 2: ni slovo adresy
GDT23    db        0                        ; 4: vy bajt adresy
GDT24    db        93h                      ; 5: bajt pstupovch prv
GDT25    dw        0                        ; 6: (rezervovno)

                                          ;* popisova clovho bloku dat
GDT31    dw        0                        ; 0: omezen segmentu
GDT32    dw        0                        ; 2: ni slovo adresy
GDT33    db        0                        ; 4: vy bajt adresy
GDT34    db        93h                      ; 5: bajt pstupovch prv
GDT35    dw        0                        ; 6: (rezervovno)

                                          ;* popisova program. segmentu BIOS
GDT41    dw        0                        ; 0: omezen segmentu
GDT42    dw        0                        ; 2: ni slovo adresy
GDT43    db        0                        ; 4: vy bajt adresy
GDT44    db        0                        ; 5: bajt pstupovch prv
GDT45    dw        0                        ; 6: (rezervovno)

                                          ;* popisova zsobnkovho segmentu
GDT51    dw        0                        ; 0: omezen segmentu
GDT52    dw        0                        ; 2: ni slovo adresy
GDT53    db        0                        ; 4: vy bajt adresy
GDT54    db        0                        ; 5: bajt pstupovch prv
GDT55    dw        0                        ; 6: (rezervovno)

GDT0     label     word                     ; konec tabulky popisova

; -----------------------------------------------------------------------------
;        Pesun bloku dat
; -----------------------------------------------------------------------------
; VSTUP: DL:SI=zdrojov adresa
;        DH:DI=clov adresa
;        CX=poet sektor k penosu
; VSTUP:CY=chyba operace
;        DL:SI=zdrojov adresa (nov hodnota)
;        DH:DI=clov adresa (nov hodnota)
;        CX=poet zbylch sektor
; -----------------------------------------------------------------------------

PUBLIC   BlokMove
BlokMove PROC      NEAR

         clc
         jcxz      BlokMov9                 ; nen dn sektor k penosu

                                          ;* omezen potu sektor
         mov       ax,127                   ; maximln poet sektor k penosu
         cmp       ax,cx                    ; je pli velk poet sektor ?
         jb        BlokMov1                 ; velk poet sektor - omezen
         mov       ax,cx                    ; poadovan poet sektor
BlokMov1:push      cx                       ; poet poadovanch sektor

                                          ;* pevod sektor na bajty
         xchg      ah,al                    ; sektory * 256
         add       ax,ax                    ; poet sektor * 512

                                          ;* popisova zdrojovho bloku
         mov       cs:[GDT21],ax            ; omezen zdrojovho bloku
         mov       cs:[GDT22],si            ; ni slovo zdrojov adresy
         mov       cs:[GDT23],dl            ; vy bajt zdrojov adresy

                                          ;* popisova clovho bloku
         mov       cs:[GDT31],ax            ; omezen clovho bloku
         mov       cs:[GDT32],di            ; ni slovo clov adresy
         mov       cs:[GDT33],dh            ; vy bajt clov adresy

                                          ;* schova registr
         push      ax                       ; schova penenho potu bajt
         push      dx
         push      si
         push      di
         push      es

                                          ;* penesen bloku dat
         mov       cx,ax                    ; poet bajt k pesunu
         shr       cx,1                     ; poet slov k penosu
         push      cs
         pop       es                       ; ES <- segment tabulky GDT
         mov       si,offset GDT            ; tabulka popisova GDT
         mov       ah,87h
         clc                                ; pednastaven pznaku NC
         int       15h                      ; penos dat v chrnnm mdu

                                          ;* nvrat obsahu registr
         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx                       ; nvrat penenho potu bajt

                                          ;* test vsledku operace
         jc        BlokMov7                 ; chyba operace
         or        ah,ah                    ; byla operace spn ?
         stc                                ; pznak chyby operace
         jnz       BlokMov7                 ; byla chyba operace

                                          ;* zven clov a zdrojov adresy
         add       si,cx                    ; zven zdrojov adresy
         adc       dl,0                     ; penos do vyho bajtu
         add       di,cx                    ; zven clov adresy
         adc       dh,0                     ; penos do vyho bajtu
         clc                                ; pznak - operace OK

BlokMov7:pop       cx                       ; nvrat poadovanho potu sektor
         jc        BlokMov9                 ; byla chyba operace
         sub       cx,127                   ; odeten max. potu sektor
         jnc       BlokMov8                 ; nebylo peteen potu
         xor       cx,cx                    ; nezbyl dn sektor
BlokMov8:jmp       short BlokMove           ; penos dalho bloku dat
BlokMov9:ret

BlokMove ENDP

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 15h
; -----------------------------------------------------------------------------

FreeMem  dw        0                        ; poet zbyl voln pamti
TopMem   dw        0                        ; poten adresa v ext. pamti
         db        0                        ; pot. adresa - vy bajt
Old15    dd        0                        ; pvodn adresa obsluhy INT 15h

Int15    PROC      FAR

         pushf
         cmp       ah,88h                   ; je dotaz na velikost pamti ?
         jne       Int151                   ; nen dotaz na velikost pamti
         popf
         mov       ax,cs:[FreeMem]          ; velikost roziujc pamti
         iret

Int151:  popf
         jmp       dword ptr cs:[old15]     ; pokraovn v pvodn obsluze

Int15    ENDP

; -----------------------------------------------------------------------------
;        Obsluha rutiny strategie
; -----------------------------------------------------------------------------

PUBLIC   Strateg
Strateg  PROC      FAR

         mov       word ptr cs:[adrzahl],bx
         mov       word ptr cs:[adrzahl+2],es
         ret

Strateg  ENDP

; -----------------------------------------------------------------------------
;        Tabulka skok
; -----------------------------------------------------------------------------

TabSkok  dw        offset Funkce00          ; 0  inicializace zazen
         dw        offset Funkce01          ; 1  kontrola mdia
         dw        offset Funkce02          ; 2  vystavn bloku parametr BPB
         dw        offset Neznama           ; 3  vstup kanlu IOCTL
         dw        offset Funkce04          ; 4  vstup - ten z disku
         dw        offset Neznama           ; 5  (nedestruktivn vstup)
         dw        offset Neznama           ; 6  (statut vstupu)
         dw        offset Neznama           ; 7  (vyprzdnn vstupu)
         dw        offset Funkce08          ; 8  vstup - zpis na zazen
         dw        offset Funkce08          ; 9  vstup s verifikac
         dw        offset Neznama           ; 0ah (statut vstupu)
         dw        offset Neznama           ; 0bh (vyprzdnn vstupu)
         dw        offset Neznama           ; 0ch vstup z kanlu IOCTL
         dw        offset Ok                ; 0dh oteven zazen
         dw        offset Ok                ; 0eh uzaven zazen
         dw        offset Ok                ; 0fh vmna mdia

; -----------------------------------------------------------------------------
;        Obsluha rutinu peruen
; -----------------------------------------------------------------------------

PUBLIC   Prerus
Prerus   PROC      FAR

         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es
         cld
         push      cs
         pop       ds
         les       bx,ds:[AdrZahl]          ; adresa zhlav zazen
         mov       word ptr es:[bx+3],8103h ; chyba - neplatn povel
         mov       al,es:[bx+2]             ; kd povelu
         cmp       al,0fh                   ; maximln povel
         ja        Prerus3                  ; chybn slo povelu
         cbw                                ; AX <- AL slo povelu
         add       ax,ax                    ; slo povelu * 2
         mov       di,ax                    ; DI <- slo povelu * 2
         mov       word ptr es:[bx+3],100h  ; nvratov kd - OK
         call      word ptr ds:[di+TabSkok] ; vyvoln obsluhy funkce
Prerus3: pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

Prerus   ENDP

; -----------------------------------------------------------------------------
;        Neobsluhovan funkce
; -----------------------------------------------------------------------------

PUBLIC   Neznama
Neznama  PROC      NEAR

         mov       word ptr es:[bx+3],8103h ; chyba - neplatn povel
Ok:      ret

Neznama  ENDP

; -----------------------------------------------------------------------------
;        Funkce 01h - kontrola vmny mdia
; -----------------------------------------------------------------------------

PUBLIC   Funkce01
Funkce01 PROC      NEAR

         mov       byte ptr es:[bx+0eh],1   ; pznak - mdium nezmnno
         ret

Funkce01 ENDP

; -----------------------------------------------------------------------------
;        Funkce 02h - vystavn bloku parametr BIOS BPB
; -----------------------------------------------------------------------------

PUBLIC   Funkce02
Funkce02 PROC      NEAR

         mov       word ptr es:[bx+12h],offset bpb ; tabulka parametr BPB
         mov       word ptr es:[bx+14h],cs         ; segment tabulky BPB
         ret

Funkce02 ENDP

; -----------------------------------------------------------------------------
;        Funkce 04h - ten z disku
; -----------------------------------------------------------------------------

PUBLIC   Funkce04
Funkce04 PROC      NEAR

         mov       cx,es:[bx+12h]           ; poet sektor ke ten
         mov       dx,es:[bx+14h]           ; poten sektor ke ten
         push      ds
         mov       di,es:[bx+0eh]           ; offset bufferu pro naten dat
         mov       ds,es:[bx+10h]           ; segment bufferu pro naten dat
         call      ReadSekt                 ; naten sektor z disku
         pop       ds
         jnc       F042                     ; operace OK

         mov       word ptr es:[bx+12h],0   ; poet penesench sektor = 0
         mov       word ptr es:[bx+3],810bh ; nvratov kd - chyba ten

F042:    ret

Funkce04 ENDP

; -----------------------------------------------------------------------------
;        Funkce 08h, 09h - zpis na zazen
; -----------------------------------------------------------------------------

PUBLIC   Funkce08
Funkce08 PROC      NEAR

         mov       cx,es:[bx+12h]           ; poet sektor k zpisu
         mov       dx,es:[bx+14h]           ; poten sektor k zpisu
         push      ds
         mov       si,es:[bx+0eh]           ; offset bufferu pro naten dat
         mov       ds,es:[bx+10h]           ; segment bufferu pro naten dat
         call      WritSekt                 ; zpis sektor na disk
         pop       ds
         jnc       F082                     ; operace OK

         mov       word ptr es:[bx+12h],0   ; poet penesench sektor = 0
         mov       word ptr es:[bx+3],810ah ; nvratov kd - chyba zpisu

F082:    ret

Funkce08 ENDP

; -----------------------------------------------------------------------------
;        Funkce 00h - inicializace zazen
; -----------------------------------------------------------------------------

PUBLIC   Funkce00
Funkce00 PROC      NEAR

         mov       si,offset UvTxt
         call      DispTxt                  ; zobrazen vodnho textu

                                          ;* kontrola velikosti pamti
         clc                                ; pednastaven NC
         mov       ah,88h
         int       15h                      ; dotaz na velikost pamti
         jc        Fn00Err                  ; chyba (nen obsluha funkce)
         sub       ax,40*9                  ; poet KB potebn pamti = 360
         jnc       Fn002                    ; pamti je dostatek

                                          ;* chyba - nedostatek pamti
Fn00Err: mov       si,offset ErrTxt         ; chybov text
         call      DispTxt                  ; zobrazen chybovho textu
         mov       byte ptr es:[bx+0dh],0   ; poet disk = 0
         mov       byte ptr ds:[PocDisku],0 ; poet disk = 0
         jmp       Fn009

                                          ;* nastaven ukazatel pamti
Fn002:   mov       ds:[FreeMem],ax          ; poet zbyl voln pamti
         mov       dl,ah
         mov       ah,al
         xor       al,al
         add       ax,ax
         adc       dl,dl
         add       ax,ax
         adc       dl,dl
         add       dl,10h                   ; piten zatku 1 MB
         mov       ds:[TopMem],ax           ; zatek RAM-DISKu (ni slovo)
         mov       byte ptr ds:[TopMem+2],dl; zatek RAM-DISKu (vy slovo)

                                          ;* instalace obsluhy INT 15h
         push      ds                       ; schova DS
         xor       ax,ax                    ; AX <- 0
         mov       ds,ax                    ; DS <- 0
         mov       ax,ds:[4*15h]            ; offset INT 15h
         mov       word ptr cs:[Old15],ax   ; schova offsetu INT 15h
         mov       ax,ds:[4*15h+2]          ; segmemt INT 15h
         mov       word ptr cs:[Old15+2],ax ; schova segmentu INT 15h
         mov       word ptr ds:[4*15h],offset Int15 ; offset obsluhy INT 15h
         mov       word ptr ds:[4*15h+2],cs ; segment obsluhy INT 15h
         pop       ds

                                          ;* inicializace disku
         push      es
         push      cs
         pop       es
         mov       di,offset boot
         mov       cx,512
         xor       ax,ax
         cld
         rep       stosb
         pop       es


         xor       dx,dx
         mov       cx,720
Fn004:   push      cx
         mov       si,offset boot
         mov       cx,1
         call      WritSekt
         pop       cx
         inc       dx
         loop      Fn004

         mov       si,offset boot0
         mov       cx,1
         mov       dx,1
         call      WritSekt

         mov       cx,1
         mov       dx,1+3
         call      WritSekt


         mov       byte ptr es:[bx+0dh],1   ; poet instalovanch disk = 1
Fn009:   mov       word ptr es:[bx+12h],offset tabbpb ; tabulka BPB
         mov       word ptr es:[bx+14h],cs  ; segment adresy tabulky BPB
         mov       word ptr es:[bx+0eh],offset Funkce00 ; konec ovladae
         mov       word ptr es:[bx+10h],cs  ; segment konce ovladae
         ret

Funkce00 ENDP


; -----------------------------------------------------------------------------
;        Zobrazen textu CS:SI
; -----------------------------------------------------------------------------

PUBLIC   DispTxt
DispTxt  PROC      NEAR

DispTxt1:mov       al,cs:[si]
         inc       si
         or        al,al
         jz        DispTxt2
         push      bx
         push      si
         push      es
         mov       ah,0eh
         mov       bx,7
         int       10h
         pop       es
         pop       si
         pop       bx
         jmp       short DispTxt1
DispTxt2:ret

DispTxt  ENDP

; -----------------------------------------------------------------------------
;        Data
; -----------------------------------------------------------------------------

UvTxt    db        'RAM-emulator disket V 1.0; (c) Miroslav Nemecek',13,10,0
ErrTxt   db        'Nedostatek pameti (EXTENDED) !',13,10,0

         EVEN
boot0    label     byte

         db        0fdh
         dw        0ffffh
         db        0

boot     label     byte                     ; zavdc sektor disku


code     ENDS

         END
